#ifndef _getFiles_H_
#define _getFiles_H_
/*  *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *
    void getfiles( folder, filename, &list)
    @param:
        folder      -   folder where search will be
                        ex. "C:\\", "D:/Music"
        filename    -   name of searched files, allow to use
                        simbols '*' and '?'
                        ex. "myFile.cpp", "*.mp3", "?.*"
        list        -   variable, type of StringList, here will
                        be stored list of founded files
    // ----------------------------------------------------------------
        'folder'   / 'filename'
          'list'.
     :
    ///     
    StringList lFiles;
    //  
    getFiles("d:/music", "*.mp3", &lFiles);
    // ,  ,     !
    //     ?
    //   -   ...
    while (!lFiles.empty)
    {
        std:cout << lFiles.front() << "\n";
        lFiles.pop_front();
    }
    // ...      .
 *  *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */

#include <list>
#include <string>
#include <direct.h>
#include <io.h>
#include <stdlib.h>

typedef std::string String;
typedef std::list<std::string> StringList;

void getFiles(
    const String& _folder,
    const String& _filename,
    StringList* _listFiles)
{
    struct _finddata_t  fileData;
    intptr_t            hFile;

    if (!_chdir(_folder.data()))
    {
        // find first file
        if ( (hFile = _findfirst(_filename.data(), &fileData)) != -1L )
        {
            do
            {
                _listFiles->push_back(fileData.name);
            }
            while (_findnext(hFile, &fileData) == 0);
            _findclose(hFile);
        }
    }
    _listFiles->push_back("-= EndOfList =-");
}

#endif /*_func_H_*/